require "luaCsnd"

csound = luaCsnd.Csound()
args = luaCsnd.CsoundArgVList()

args_ = {"csound","-o", "dac", "sine.csd"}
for i,v in ipairs(args_) do
    args:Append(v)
end

--a few Csound API INSTANTIATION methods
print("*** PRECOMPILE result **** = ", csound:PreCompile())
print("*** GETVERSION result **** = ", luaCsnd.csoundGetVersion()/1000)
print("*** GETAPIVERSION result **** =",luaCsnd.csoundGetAPIVersion() /100)

--a few Csound API ATTRIBUTES methods
print("*** GETSR result **** = ", csound:GetSr())
print("*** GETKR result **** = ", csound:GetKr())
print("*** GETKSMPS result **** = ", csound:GetKsmps())
print("*** GETNCHNLS result **** = ", csound:GetNchnls())
print("*** GET0DBFS result **** = ", csound:Get0dBFS())

--a Csound API MESSAGES & TEXT method
mymessage = "**** A MESSAGE FROM MYCSOUND API **** \n"
csound:Message(mymessage)

result = csound:Compile(args.argc(args), args.argv(args))

pt = luaCsnd.CsoundPerformanceThread(csound)
pt:Play()
luaCsnd.csoundSleep(10000)
luaCsnd.csoundSleep(10000)
pt:Stop()
pt:Join()
csound:Reset()
args:Clear()


